#include <stdlib.h>
#include <stdint.h>
#include <avr/io.h>
#define F_CPU	8000000
#include <util/delay.h>
#include "lcd.h"

int8_t LCDMenuPoint;
unsigned int i;

void ShowMainMenue(void);
void DisplayHeader(void);
void ShowTempMenue(void);


void DisplayHeader(void)
{
    lcd_clrscr();
    lcd_puts("  Einstellungsmenu  ");
    lcd_gotoxy(0,1);
	lcd_puts("--------------------");
    lcd_gotoxy(0,2);
}

void ShowTempMenue(void)
{
    DisplayHeader();
	_delay_ms(1);
//	lcd_puts("  Temperatur ");
/*
lcd_putc(0x3D);
lcd_puts(" 22");
lcd_putc(0xDF);
lcd_puts("C ");
lcd_gotoxy(0,3);
lcd_puts("       ");
lcd_putc(0x3E);
lcd_puts(" OK ");
lcd_putc(0x3C);
*/
}

void ShowMainMenue(void)
{
	DisplayHeader();
	
	if (LCDMenuPoint == 1) {
		lcd_puts("  >");
	} else {
		if (LCDMenuPoint == 2)
			lcd_puts("   ");
	}

	lcd_puts("  Temperatur  ");

	if (LCDMenuPoint == 1) {
		lcd_puts("<  ");
	} else {
		if (LCDMenuPoint == 2)
		lcd_puts("   ");
	}

    lcd_gotoxy(0,3);

	if (LCDMenuPoint == 1) {
		lcd_puts("   ");
	} else {
		if (LCDMenuPoint == 2)
		lcd_puts("  >");
	}

	lcd_puts("  Differenz   ");

	if (LCDMenuPoint == 1) {
		lcd_puts("   ");
	} else {
		if (LCDMenuPoint == 2)
		lcd_puts("<  ");
	}
}

int main(void)
{
	LCDMenuPoint = 0;
	i = 0;
	
	DDRB = 0xFF;

	DDRD  &= ~(1 << PD4);  /* Pin PD3 als Eingang */
	PORTD |= (1 << PD4);    /* internen Pull-Up an PD3 aktivieren */

	DDRD  &= ~(1 << PD3);  /* Pin PD3 als Eingang */
	PORTD |= (1 << PD3);    /* internen Pull-Up an PD3 aktivieren */

	DDRD  &= ~(1 << PD2);  /* Pin PD3 als Eingang */
	PORTD |= (1 << PD2);    /* internen Pull-Up an PD3 aktivieren */
	

	_delay_ms(100);
	PORTB = PINB ^ (1 << PB1);
	_delay_ms(1000);
	PORTB = PINB ^ (1 << PB1);
	_delay_ms(2500);
		
    lcd_init(LCD_DISP_ON);
    lcd_clrscr();

    while(1)
	{
		if ( !(PIND & (1<<PIND3)) )					// Runter
		{
			_delay_ms(100);
			
			if ( !(PIND & (1<<PIND3)) )
			{
				if (LCDMenuPoint == 1)
				{
					LCDMenuPoint = 2;
					ShowMainMenue();
				}
			}
		}

		if ( !(PIND & (1<<PIND2)) )					// Rauf
		{
			_delay_ms(100);
			
			if ( !(PIND & (1<<PIND2)) )
			{
				if (LCDMenuPoint == 2)
				{
					LCDMenuPoint = 1;
					ShowMainMenue();
				}
			}
		}

		if ( !(PIND & (1<<PIND4)) )					// Mitte
		{
			_delay_ms(100);
			
			if ( !(PIND & (1<<PIND4)) )
			{
				if (LCDMenuPoint == 0)
				{
					LCDMenuPoint = 1;
					ShowMainMenue();
				} else {
					if (LCDMenuPoint == 1)
					{
//						LCDMenuPoint = 3;			// Fehlerzeile
						ShowTempMenue();
					}
				}
			}
		}
    }
}
